function [F] = F_delayed_vdP(x,lambda)

%%% input: x = (omega,a), where
%%%    - omega is the (complex) frequency of the periodic solution
%%%    - a is the vector of Fourier coefficients in C^(2m-1)
%%%    - lambda is the parameter

global tau eps

m=length(x)/2;

omega = x(1); %%% The frequency of the periodic orbit
a = x(2:end);

[a3]=cubic(a,a,a);

k=(-m+1:m-1)';
mu=-k.^2*omega^2-eps*1i*k*omega-lambda+exp(-1i*k*omega*tau);

eta=sum(a(m-3:m+3)); % F0 = sum_{|k|<=3} a_k, since u(0) approx 0 (phase condition)

g=mu.*a+1i*eps*k*omega.*a3/3;

F=[eta;g];

end

