function [I,success]=radii_polynomials_delayed_vdP(x0,x1,lambda0,lambda1,nu)

m=length(x0)/2;

global tau eps

del_bx=x1-x0;
del_ba=del_bx(2:end);
del_omega=del_bx(1);
del_lbda=lambda1-lambda0;

omega0 = x0(1); %%% The frequency of the periodic orbit
%omega1 = x1(1); %%% The frequency of the periodic orbit

a0=x0(2:end);

DF=DF_delayed_vdP(x0,lambda0);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Definition of the symmetric operator A %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

A0=inv(DF); %%% A0 is the inverse without imposing the "real" symmetry

[A] = symmetrize_A(A0);

%%%%%%%%%
%%% Y0 %%%
%%%%%%%%%

%%% w0 %%%
a0_ext=[zeros(2*m-2,1);a0;zeros(2*m-2,1)];
[a03]=cubic(a0_ext,a0_ext,a0_ext);
k=(-3*m+3:3*m-3)';
mu0=-k.^2*omega0^2-eps*1i*k*omega0-lambda0+exp(-1i*k*omega0*tau);
eta0=sum(a0(m-3:m+3)); % F0 = sum_{|k|<=3} a_k, since u(0) approx 0 (phase condition)
g0=mu0.*a0_ext+1i*eps*k*omega0.*a03/3;

y0=[eta0;g0];

w0F=A*padding(y0,-(2*m-2));
w0=[g0(1:2*m-2)./mu0(1:2*m-2);w0F(2:end);g0(4*m-2:6*m-5)./mu0(4*m-2:6*m-5)];
w0=max(abs(w0F(1)),sum(abs(w0).*nu.^abs(k)));

%%% w1 %%%

del_ba_ext=[zeros(2*m-2,1);del_ba;zeros(2*m-2,1)];
[a02del_ba]=cubic(a0_ext,a0_ext,del_ba_ext);

g1=1i*eps*k.*a02del_ba*omega0+(1/3)*1i*eps*k*del_omega.*a03-1i*eps*k*omega0.*del_ba_ext ... 
    -1i*eps*k*del_omega.*a0_ext-k.^2*omega0^2.*del_ba_ext-2*k.^2*del_omega*omega0.*a0_ext ... 
    -1i*exp(-1i*k*tau*omega0).*a0_ext.*k*tau*del_omega-lambda0*del_ba_ext-del_lbda*a0_ext ...
    +exp(-1i*k*tau*omega0).*del_ba_ext;

y1=[sum(a0(m-3:m+3));g1];

w1F=A*padding(y1,-(2*m-2));
w1=[g1(1:2*m-2)./mu0(1:2*m-2);w1F(2:end);g1(4*m-2:6*m-5)./mu0(4*m-2:6*m-5)];
w1=max(abs(w1F(1)),sum(abs(w1).*nu.^abs(k)));

%%% w2 %%%

[del_ba3]=cubic(del_ba_ext,del_ba_ext,del_ba_ext);
[a0del_ba2]=cubic(a0_ext,del_ba_ext,del_ba_ext);

sigma=1/2; % Will have to be changed to sigma=infsup(0,1);

g2=2*1i*eps*k*sigma.*del_ba3*(sigma*del_omega+omega0) ...
    +2*1i*eps*k.*a0del_ba2*(3*sigma*del_omega+omega0) ...
    +2*1i*eps*k*del_omega.*a02del_ba-6*k.^2*sigma*del_omega^2.*del_ba_ext ...
    -sigma*del_ba_ext.*k.^2*tau^2*del_omega^2.*exp(-1i*k*tau*(sigma*del_omega+omega0)) ...
    -(2*1i)*eps*k.*del_ba_ext*del_omega-4*k.^2*del_omega*omega0.*del_ba_ext-2*k.^2*del_omega^2.*a0_ext ...
    -a0_ext.*k.^2*tau^2*del_omega^2.*exp(-1i*k*tau*(sigma*del_omega+omega0)) ...
    -(2*1i)*del_ba_ext.*k*tau*del_omega.*exp(-1i*k*tau*(sigma*del_omega+omega0)) ...
    -2*del_lbda*del_ba_ext;

y2=[0;g2];

w2F=A*padding(y2,-(2*m-2));
w2=[g2(1:2*m-2)./mu0(1:2*m-2);w2F(2:end);g2(4*m-2:6*m-5)./mu0(4*m-2:6*m-5)];
w2=max(abs(w2F(1)),sum(abs(w2).*nu.^abs(k)));

Y0=w0+w1+w2;

%%%%%%%%%%%%%%%%%%
%%% Z0, Z1, Z2 & Z3 %%%
%%%%%%%%%%%%%%%%%%

%%% Z0 %%%

nu_power = nu.^abs(-m+1:m-1);

B = abs(eye(2*m)-A*DF);

Z0=zeros(2,1);

Z0(1) = B(1,1) + max(B(1,2:2*m)./nu_power);

z011 = sum(B(2:2*m,1).*nu_power');
z012 = max(sum(B(2:2*m,2:2*m).*repmat(nu_power,2*m-1,1)')./nu_power);
Z0(2) = z011 + z012;

Z0=max(Z0);

%%% Z1 %%%

Z1=zeros(2,1);

A_a0 = A(1,2:end);
A_a1 = A(2:end,2:end);

a0_nu_norm=sum(abs(a0).*nu_power');

a02 = quadratic([zeros(m-1,1);a0;zeros(m-1,1)],[zeros(m-1,1);a0;zeros(m-1,1)]);

Psi_ka02 =zeros(2*m-1,1);

for k1=-m+1:m-1    
    j1=(k1-2*(m-1):-m)'; j2=(m:2*(m-1)+k1)';    
    Psi_ka02(k1+m)=max([max(abs(a02(k1-j1+2*(m-1)+1))./nu.^abs(j1)),max(abs(a02(k1-j2+2*(m-1)+1))./nu.^j2)]);
end

zeta=eps*abs((-m+1:m-1)')*abs(omega0).*Psi_ka02;

Z1(1)=abs(A_a0)*zeta;

z1_temp=[a03(1:2*m-2)./mu0(1:2*m-2);zeros(2*m-1,1);g0(4*m-2:6*m-5)./mu0(4*m-2:6*m-5)];

Z1(2)=sum((abs(A_a1)*zeta).*nu.^(-m+1:m-1)')+ ... 
    (1/3)*eps*sum(abs(z1_temp.*abs(k)).*nu.^abs((-3*m+3:3*m-3)')) + ...
    eps*omega0/(m*(omega0^2-(abs(lambda0)+1)/m^2))*a0_nu_norm^2;

Z1=max(Z1);

%%% Z2 %%%

k=(-m+1:m-1);

tA_a0=abs(k.*A_a0);
tB_a0=k.^2.*abs(A_a0);
tA_a1=abs(diag(k)*A_a1);
tB_a1=diag(k.^2)*abs(A_a1);

norm_A(1) = max(abs(A_a0)./nu_power);
norm_A(2) = max(max(sum(abs(A_a1).*repmat(nu_power,2*m-1,1)')./nu_power),1/(m^2*(omega0^2-(abs(lambda0)+1)/m^2)));

norm_tA(1) = max(abs(tA_a0)./nu_power);
norm_tA(2) = max(max(sum(abs(tA_a1).*repmat(nu_power,2*m-1,1)')./nu_power),1/(m*(omega0^2-(abs(lambda0)+1)/m^2)));

norm_tB(1) = max(abs(tB_a0)./nu_power);
norm_tB(2) = max(max(sum(abs(tB_a1).*repmat(nu_power,2*m-1,1)')./nu_power),1/((omega0^2-(abs(lambda0)+1)/m^2)));

Z2_1 = zeros(2,1);
Z2_2 = zeros(2,1);
Z2_3 = zeros(2,1);
Z2_4 = zeros(2,1);

for j=1:2
    if j==1
        tAaj=tA_a0; tBaj=tB_a0; 
    end
    if j==2
        tAaj=tA_a1; tBaj=tB_a1; 
    end

    Z2_1(j)=(2+tau^2)*abs(del_omega)*nu_norm(tBaj*(abs(del_ba)+abs(a0)),nu,j) ...
                 + 2*(abs(del_omega)+omega0)*nu_norm(tBaj*abs(del_ba),nu,j)+(eps+tau)*nu_norm(tAaj*abs(del_ba),nu,j) ...
                 + 2*(abs(del_omega)+omega0)*abs(del_omega)*norm_tB(j)+(eps+tau)*abs(del_omega)*norm_tA(j) ...
                 +abs(del_lbda)*norm_A(j)+eps*norm_tA(j)*nu_norm(abs(del_ba)+abs(a0),nu,2)^2*nu_norm(del_ba,nu,2) ...
                 +eps*abs(del_omega)*norm_tA(j)*nu_norm(abs(del_ba)+abs(a0),nu,2)^2 ...
                 +2*eps*(abs(del_omega)+omega0)*norm_tA(j)*nu_norm(abs(del_ba)+abs(a0),nu,2)*nu_norm(del_ba,nu,2);

     Z2_2(j)=6*eps*abs(del_omega)*norm_tA(j)*nu_norm(del_ba,nu,2)+4*eps*abs(del_omega)*norm_tA(j)*nu_norm(a0,nu,2) ...
                +4*eps*omega0*norm_tA(j)*nu_norm(del_ba,nu,2)+2*eps*omega0*norm_tA(j)*nu_norm(a0,nu,2) ...
                +tau*norm_tA(j)+4*abs(del_omega)*norm_tB(j)+2*omega0*norm_tB(j)+(eps+tau)*norm_tA(j)+eps*norm_tA(j) ...
                +4*abs(del_omega)*norm_tB(j)+tau^2*norm_tB(j)*nu_norm(abs(del_ba)+abs(a0),nu,2)+2*omega0*norm_tB(j) ...
                +4*norm_tB(j)*nu_norm(del_ba,nu,2)+tau^2*abs(del_omega)*norm_tB(j)+6*eps*norm_tA(j)*nu_norm(del_ba,nu,2)^2 ...
                +2*eps*norm_tA(j)*nu_norm(a0,nu,2)^2+2*norm_tB(j)*nu_norm(a0,nu,2)+4*eps*norm_tA(j)*nu_norm(del_ba,nu,2)*nu_norm(a0,nu,2);

      Z2_3(j)=tau^2*norm_tB(j)+4*norm_tB(j)+2*norm_tB(j)+3*eps*norm_tA(j)*nu_norm(del_ba,nu,2)+2*eps*norm_tA(j)*nu_norm(a0,nu,2) ...
                + 3*eps*abs(del_omega)*norm_tA(j)+6*eps*norm_tA(j)*nu_norm(del_ba,nu,2)+4*eps*norm_tA(j)*nu_norm(a0,nu,2)+2*eps*omega0*norm_tA(j);

      Z2_4(j)=4*eps*norm_tA(j);

end

Z2_1 = max(Z2_1);
Z2_2 = max(Z2_2);
Z2_3 = max(Z2_3);
Z2_4 = max(Z2_4);

%%% Radii Polynomials %%%

P = [Z2_4 Z2_3 Z2_2 Z2_1+Z1+Z0-1 Y0];

R=sort(roots(P)); R=sort(R(R>0))';

if norm(imag(R)) >0
    success=0;
    I=[-1 -1];
    return
end

if length(R)<1
    success=0;
    I=[-1 -1];
else
    r_min=max(R(:,1)); r_max=min(R(:,2));
    if r_min<r_max
        I=[r_min r_max];
        success=1;
    else
        I=[-1 -1];
        success=0;
    end
end

end

function [nu_norm] = nu_norm(x,nu,j)

if j==1
    nu_norm=abs(x);
end

if j==2;
    a=x;
    m=(length(a)+1)/2;
    k=(-m+1:m-1)';
    nu_norm=sum(abs(a).*nu.^k);
end

end