clear
close all

load pt0_branch1
lambda_max=0.65;

x=x0;
lambda=lambda0;
global tau eps
tau=tau0; eps=eps0;

delta0=2e-5;

[tot_x,tot_lambda,tot_I,tot_delta,tot_norm] = validated_continuation_delayed_vdP(x,lambda,delta0,lambda_max);

figure
plot_periodic_complex(tot_x(:,end));

figure
plot(tot_lambda(1:10:end),tot_norm(1:10:end),'linewidth',3,'color',[.8 0 0])
axis tight
box off
set(gca,'FontSize',15)
xlabel('$$\lambda$$', 'Interpreter', 'latex', 'FontSize', 25)
ylabel('$$\|a\|$$', 'Interpreter', 'latex', 'FontSize', 25)

figure
plot(tot_lambda(1:10:end),2*pi./tot_x(1,1:10:end),'linewidth',3,'color',[0 .5 0])
axis tight
box off
set(gca,'FontSize',15)
xlabel('$$\lambda$$', 'Interpreter', 'latex', 'FontSize', 25)
ylabel('$$p$$', 'Interpreter', 'latex', 'FontSize', 25)

figure
plot(tot_lambda(1:end-1),tot_delta,'linewidth',3)
axis tight
box off
set(gca,'FontSize',15)
xlabel('$$\lambda$$', 'Interpreter', 'latex', 'FontSize', 25)
ylabel('$$\Delta_\lambda$$', 'Interpreter', 'latex', 'FontSize', 25)
