clear
close all

%load pt0_branch2, lambda_max=-0.476; delta0=2e-5;
load pt2_branch2, lambda_max=-0.49; delta0=7e-5;

x=x0;
lambda=lambda0;
global tau eps
tau=tau0; eps=eps0;

[tot_x,tot_lambda,tot_I,tot_delta,tot_norm] = validated_continuation_delayed_vdP(x,lambda,delta0,lambda_max);

figure
[max_norm,k] = max(tot_norm);
plot_periodic_complex(tot_x(:,k));

figure
plot(tot_lambda(1:20:end),2*pi./tot_x(1,1:20:end),'linewidth',3,'color',[0 .5 0])
axis tight
box off
set(gca,'FontSize',15)
xlabel('$$\lambda$$', 'Interpreter', 'latex', 'FontSize', 25)
ylabel('$$p$$', 'Interpreter', 'latex', 'FontSize', 25)

figure
plot(tot_lambda(1:end-1),tot_delta,'linewidth',3)
axis tight
box off
set(gca,'FontSize',15)
xlabel('$$\lambda$$', 'Interpreter', 'latex', 'FontSize', 25)
ylabel('$$\Delta_\lambda$$', 'Interpreter', 'latex', 'FontSize', 25)

figure
plot(tot_lambda,tot_norm,'linewidth',3,'color',[.7 0 0])
axis tight
box off
set(gca,'FontSize',15)
xlabel('$$\lambda$$', 'Interpreter', 'latex', 'FontSize', 25)
ylabel('$$\|a\|$$', 'Interpreter', 'latex', 'FontSize', 25)
